#!/usr/bin/env python
# -*- coding: utf-8 -*-

"""
Скрипт возвращает регулярное выражение для run-parts для механизма first-run на основе файла regexp_filename и
директории со скриптами scripts_dirname
"""

import os
import string
import sys

def check(script_filename, params):
	for param in params:
		script_filename2 = os.path.basename(script_filename)
		pos = script_filename2.find('_')
		script_filename2 = script_filename2[pos:].strip()
		if "_" + param.strip() == script_filename2:
			return True
	return False

def get_params_from_file(regexp_filename, scripts_dirname):
	param_filenames = []
	regexp_file = open(regexp_filename)
	params = regexp_file.readlines()
	regexp_file.close()

	for item in os.listdir(scripts_dirname):
		if not os.path.isdir(scripts_dirname + "/" + item):
			if not check(scripts_dirname + "/" + item, params):
				param_filenames.append("^" + item + "$")
	print string.join(param_filenames, "|")

def main():
	if len(sys.argv) == 3:
		regexp_filename = sys.argv[1]
		scripts_dirname = sys.argv[2]
		if os.path.exists(regexp_filename):
			get_params_from_file(regexp_filename, scripts_dirname)
		else:
			print "."
		pass
	else:
		sys.exit(1)

if __name__ == "__main__":
	os.chdir(os.path.dirname(os.path.abspath(__file__)))
	main()